import Request from '../common/request.js';
let request = new Request().http

 
 export function getIndexData() {
 	 return request('/app/index/getIndexData',null,'GET');
 }
 
 export function getFamousPrescribeList(data) {
 	 return request('/app/index/getFamousPrescribeList',data,'GET');
 }
 export function getFamousPrescribeById(data) {
 	 return request('/app/index/getFamousPrescribeById',data,'GET');
 }
 export function getQuestionsList(data) {
 	 return request('/app/index/getQuestionsList',data,'GET');
 }
 export function getQuestionsById(data) {
 	 return request('/app/index/getQuestionsById',data,'GET');
 }
 export function getMedicatedFoodList(data) {
 	 return request('/app/index/getMedicatedFoodList',data,'GET');
 }
 export function getMedicatedFoodById(data) {
 	 return request('/app/index/getMedicatedFoodById',data,'GET');
 }
 export function getVesselList(data) {
 	 return request('/app/index/getVesselList',data,'GET');
 }
 export function getVesselById(data) {
 	 return request('/app/index/getVesselById',data,'GET');
 }
 export function getChineseMedicineList(data) {
 	 return request('/app/index/getChineseMedicineList',data,'GET');
 }
 export function getChineseMedicineById(data) {
 	 return request('/app/index/getChineseMedicineById',data,'GET');
 }
 
 
 export function bdCallBackReq(data) {
 	 return request('/app/common/bdCallBack',data,'GET');
 }
 
export function aiChatListByUser(data) {
	 const url = '/doctorAi/app/aiDoctor/chatListByUser?doctorId='+data.doctorId+'&userId='+data.userId+'&patientId='+data.patientId
 	 return request(url,null,'POST','application/json;charset=UTF-8');
 }
 
export function getLocation() {
  return new Promise((resolve, reject) => {
    // #ifdef APP
    uni.getLocation({
      type: 'gcj02', // 必须设置为gcj02
      geocode: true, // 是否解析地址信息，仅App支持
      isHighAccuracy: true, // 开启高精度
      success: (res) => {
			resolve({
			   ...res.address,
			   longitude: res.longitude,
			   latitude: res.latitude
			})
       },
       fail: (err) => {
		   console.log(err)
		   reject(new Error('获取地理位置信息失败'))
       }
    })
    // #endif
    
    // #ifdef H5

	 uni.getLocation({
	    type: 'gcj02', //wgs84
	   isHighAccuracy: true, // 开启高精度定位
	   success: function (res) {
	 		console.log("qxj longitude:"+res.longitude);
			uni.showToast({icon:'none',title: "qxj res:"+JSON.stringify(res)});
	 		uni.request({
	 		  method: "post",
	 		  url: "https://restapi.amap.com/v3/geocode/regeo?key=ae15f2eb04bbc8e9f2963430f0943a42&location="+res.longitude+","+res.latitude+"&output=JSON",
	 		  data: null,
	 		  success: ({ data }) => {
	 				console.log("qxj location:"+JSON.stringify(data));
	 				const { addressComponent, formatted_address } = data.regeocode
	 				//const [longitude, latitude] = addressComponent.streetNumber.location.split(',')
					let addrCity=addressComponent.city;
					if(Array.isArray(addressComponent.city)){
						addrCity=addressComponent.province;
					}
	 				resolve({
	 					  province: addressComponent.province,
	 					  city: addrCity,
	 					  district: addressComponent.district,
	 					  street: addressComponent.township,
	 					  address: formatted_address
	 				})
	 		  },
	 		  fail: (error) => {
	 			console.log(error)
	 			reject(new Error('获取地理位置信息失败'))
	 		  }
	 		});
	   },
	   fail:function(res){
	   	   //console.log(res);
		   //uni.showToast({icon:'none',title: "qxj longitude error:"+JSON.stringify(res),duration:10000});
	   	}
	 });
    // #endif
  })
}


function getH5Location(){
	uni.getLocation({
	   type: 'gcj02',
	  //isHighAccuracy: true, // 开启高精度定位
	  success: ({ longitude, latitude }) => {
			console.log("qxj longitude:"+longitude);
			uni.request({
			  method: 'GET',
			  url: 'https://restapi.amap.com/v3/geocode/regeo?parameters',
			  data: {
				key: 'ae15f2eb04bbc8e9f2963430f0943a42',
				location: `${longitude},${latitude}`,
				output: 'JSON'
			  },
			  success: ({ data }) => {
					console.log("qxj location:"+JSON.stringify(data));
					const { addressComponent, formatted_address } = data.regeocode
					const [longitude, latitude] = addressComponent.streetNumber.location.split(',')
					resolve({
						  longitude,
						  latitude,
						  province: addressComponent.province,
						  city: addressComponent.city,
						  district: addressComponent.district,
						  street: addressComponent.township,
						  address: formatted_address
					})
			  },
			  fail: (error) => {
				console.log(error)
				reject(new Error('获取地理位置信息失败'))
			  }
			});
	  }
	});
}
