import App from './App'
import uviewPlus from '@/uni_modules/uview-plus'
import {parseIDCardInfo,logout,parseText,getDictLabelName,parseIdCard,getAge,parsePhone,isEmpty,isLogin,navBack,navTo,getUserInfo,formatHour,dateFormatStr,
registerIdCode,updateMsgDot,handleBindCompanyFsUser,setSource,loginOut} from './utils/common.js'
import { showLoginPage,getRegistrationID } from './utils/login.js'
import { formatSeconds,formatDate } from './utils/tools.js'
import { qconfig } from './utils/config.js'
// 时间格式化
import timeFormat from './utils/timeFormat.js'

// #ifndef VUE3
import Vue from 'vue'
import './uni.promisify.adaptor'
Vue.config.productionTip = false
App.mpType = 'app'
const app = new Vue({
  ...App
})
app.$mount()
// #endif

// #ifdef VUE3
import { createSSRApp } from 'vue'
export function createApp() {
	const app = createSSRApp(App)
	app.use(uviewPlus)
	app.config.globalProperties.$isLogin = isLogin
	app.config.globalProperties.$isEmpty = isEmpty
	app.config.globalProperties.$parsePhone = parsePhone
	app.config.globalProperties.$showLoginPage = showLoginPage
	app.config.globalProperties.$getRegistrationID = getRegistrationID
	app.config.globalProperties.$navBack = navBack
	app.config.globalProperties.$navTo = navTo
	app.config.globalProperties.$qconfig = qconfig
	app.config.globalProperties.$getAge = getAge
	app.config.globalProperties.$parseIdCard = parseIdCard
	app.config.globalProperties.$getDictLabelName = getDictLabelName
	app.config.globalProperties.$parseText = parseText
	app.config.globalProperties.$logout = logout,
	app.config.globalProperties.$getUserInfo = getUserInfo,
	app.config.globalProperties.$dateFormatStr = dateFormatStr,
	app.config.globalProperties.$registerIdCode = registerIdCode,
	app.config.globalProperties.$formatSeconds = formatSeconds, 
	app.config.globalProperties.$formatDate = formatDate,
	app.config.globalProperties.$parseIDCardInfo = parseIDCardInfo
	app.config.globalProperties.$timeFormat = timeFormat;
	app.config.globalProperties.$formatHour = formatHour;
	app.config.globalProperties.$updateMsgDot = updateMsgDot;
	app.config.globalProperties.$handleBindCompanyFsUser = handleBindCompanyFsUser;
	app.config.globalProperties.$setSource = setSource;
	return {
		app
	}
}
// #endif